#21 Python異常

前言

運行程序時經常遇到各種錯誤,例如:ImportError(導入模塊錯誤)、IndexError(索引錯誤)、NameError(變量錯誤)、SyntaxError(語法錯誤)、IndentationError(縮進錯誤)等,你或許有許多疑問,為什麼程序出現這個錯誤就會打印出相應的錯誤信息,自己是否可以編寫一個錯誤呢?這些錯誤在Python中其實是異常,正確的處理異常會讓程序跑起來得心應手,那麼怎麼來處理異常呢?Here we go!

Python異常

1.1 異常的名詞解釋

異常其實是一個Python對象,當Python無法正常處理程序時,就會實例化這個對象,從而拋出異常(表示一個錯誤)

1.2 異常捕捉

當程序出現異常時,如果不處理則會終止程序的運行,如果不想在發生異常時終止程序,則需要使用try來捕捉它,先來看最簡單的使用方法:

 1 name = 'MinuteSheep' # 初始化變量name
 2 print(name)   # 將變量name打印出來
 3 
 4 print(age)    # 將變量age打印出來,並沒有初始化age,會拋出變量錯誤異常
 5 
 6 # 運行結果:
 7 MinuteSheep   # 正確打印出name變量
 8 Traceback (most recent call last):       # age變量拋出變量錯誤異常
 9   File "1.py", line 4, in <module>
10     print(age)   # 將變量age打印出來,並沒有初始化age,會拋出變量錯誤異常
11 NameError: name 'age' is not defined
 1 name = 'MinuteSheep'
 2 print(name)
 3 
 4 try:    # 使用try捕捉異常
 5     print(age)
 6 except NameError:   # 當NameError出現時,執行下列代碼塊
 7     print('變量錯誤異常被捕捉')   
 8     print(NameError)
 9 
10 # 運行結果:
11 MinuteSheep
12 變量錯誤異常被捕捉
13 <class 'NameError'>
14 
15 # 可以看到當出現NameError時,並沒有終止程序,而是執行出現異常時的代碼塊

從上面的代碼可以看到,當開始執行一個try語句時,Python將會在當前程序的上下文做標記,當異常出現時,返回這裏,執行異常時的代碼塊,當然也可以捕捉多個異常:

 1 Traceback (most recent call last):
 2 name = 'MinuteSheep'
 3 print(name)
 4 
 5 try:
 6     print(age)
 7 except NameError:
 8     print('我是NameError')
 9 except KeyError:
10     print('我是KeyError')
11 
12 
13 # 運行結果:
14 MinuteSheep
15 我是NameError

長上面代碼可以看出,當有多個except語句時,會從第一個except語句開始匹配,如果匹配到則執行對於的代碼塊,剩下的except語句則不運行。多個異常的捕捉這樣寫會使代碼變得冗長,為了簡化代碼也可以這樣寫:

 1 try:
 2     print(age)
 3 except (NameError, KeyError):   # 將所有異常放在一行一起處理
 4     print('異常被正確捕捉')
 5 
 6 
 7 # 運行結果:
 8 異常被正確捕捉
 9 
10 # 這樣寫可以使代碼輕量化,但是缺點就是不能單獨的處理每一個異常,只能一起處理

有時候需要將異常打印出來,但是異常通常是一個很長的單詞,可以使用as給異常起別名:

 1 try:
 2     print(age)
 3 except NameError as e:   # 給異常起一個別名
 4     print('我是NameError')
 5     print(e)   # 將這個異常打印出來
 6 
 7 
 8 # 運行結果:
 9 我是NameError
10 name 'age' is not defined

1.3 異常的其他語法

其他語法一:

1 try:
2     try代碼
3 except:
4     except代碼
5 else:
6     else代碼

解釋:先執行try代碼,當try代碼出現異常時,執行except代碼;當try代碼沒有異常時,執行else代碼,看例:

 1 try:
 2     print(age)
 3 except NameError as e:
 4     print(e)
 5 else:
 6     print('沒有出現異常哦')
 7 
 8 
 9 # 運行結果:
10 name 'age' is not defined
11 
12 # 出現異常,執行except代碼塊,不執行else代碼塊
 1 age = 100
 2 
 3 try:
 4     print(age)
 5 except NameError as e:
 6     print(e)
 7 else:
 8     print('沒有出現異常哦')
 9 
10 
11 # 運行結果:
12 100
13 沒有出現異常哦
14 
15 # 沒有出現異常,則執行else代碼塊

其他語法二:

1 try:
2     try代碼
3 except:
4     except代碼
5 else:
6     else代碼
7 finally:
8     finally代碼

解釋:不管是否有異常,最後都執行finally代碼,看例:

 1 try:
 2     print(age)
 3 except NameError as e:
 4     print(e)
 5 else:
 6     print('沒有出現異常')
 7 finally:
 8     print('最後都得執行我')
 9 
10 # 運行結果:
11 name 'age' is not defined
12 最後都得執行我

Python異常中,最常使用的就是try……except……,else和finally語句並不常見

1.4 異常種類

常見的異常種類:

SystemExit                   解釋器請求退出
KeyboardInterrupt            用戶中斷執行(通常是輸入^C)
StopIteration                迭代器沒有更多的值
GeneratorExit                生成器(generator)發生異常來通知退出
StandardError                所有的內建標準異常的基類
ArithmeticError              所有數值計算錯誤的基類
FloatingPointError           浮點計算錯誤
OverflowError                數值運算超出最大限制
ZeroDivisionError            除(或取模)零 (所有數據類型)
AssertionError               斷言語句失敗
AttributeError               對象沒有這個屬性
EOFError                     沒有內建輸入,到達EOF 標記
EnvironmentError             操作系統錯誤的基類
IOError                      輸入/輸出操作失敗
OSError                      操作系統錯誤
WindowsError                 系統調用失敗
ImportError                  導入模塊/對象失敗
LookupError                  無效數據查詢的基類
IndexError                   序列中沒有此索引(index)
KeyError                     映射中沒有這個鍵
MemoryError                  內存溢出錯誤(對於Python 解釋器不是致命的)
NameError                    未聲明/初始化對象 (沒有屬性)
UnboundLocalError            訪問未初始化的本地變量
ReferenceError               弱引用(Weak reference)試圖訪問已經垃圾回收了的對象
RuntimeError                 一般的運行時錯誤
NotImplementedError          尚未實現的方法
SyntaxError                  Python 語法錯誤
IndentationError             縮進錯誤
TabError                     Tab 和空格混用
SystemError                  一般的解釋器系統錯誤
TypeError                    對類型無效的操作
ValueError                   傳入無效的參數
UnicodeError                 Unicode 相關的錯誤
UnicodeDecodeError           Unicode 解碼時的錯誤
UnicodeEncodeError           Unicode 編碼時錯誤
UnicodeTranslateError        Unicode 轉換時錯誤
DeprecationWarning           關於被棄用的特徵的警告
FutureWarning                關於構造將來語義會有改變的警告
OverflowWarning              舊的關於自動提升為長整型(long)的警告
PendingDeprecationWarning    關於特性將會被廢棄的警告
RuntimeWarning               可疑的運行時行為(runtime behavior)的警告
SyntaxWarning                可疑的語法的警告
UserWarning                  用戶代碼生成的警告

可以看到上面這麼多異常,怎麼可以記得住啊!!!其實,Python中,所有異常都有一個共同的基類BaseException,它包含所有的異常,常規異常的基類是Exception

當不清楚會出現什麼異常的時候,直接捕捉Exception基本上都是可以捕捉到的:

1 try:
2     print(age)
3 except Exception as e:   # 使用常規異常的基類
4     print(e)
5 
6 
7 # 運行結果:
8 name 'age' is not defined

1.5 主動出發異常

異常可以使用raise主動觸發,看例:

1 try:
2     raise Exception('主動拋出異常')    # 使用raise主動觸發異常
3 except Exception as e:
4     print(e)
5 
6 
7 # 運行結果:
8 主動拋出異常

1.6 自定義異常

Python中所有的異常的基類都是BaseException,常見的異常的基類是Exception,那麼自己如果想要自定義異常的話,也要以BaseException或者Exception為基類(關於類的講解以後會介紹到,這裏先看一看)

class MSException(Exception):
    def __init__(self, content):
    ¦   self.content = content

    def __str__(self):
    ¦   return self.content


try:
    raise MSException('這是MinuteSheep自定義的異常')    # 拋出自定義異常
except Exception as e:
    print(e)


# 運行結果:
這是MinuteSheep自定義的異常

1.7 斷言

這是一個新名詞,斷言是個什麼鬼呢?斷言是用來檢測條件是否正確的。有這麼一句話:與其讓程序在運行時出錯,不如讓其出現錯誤條件時出錯。斷言語句的關鍵字為:assert

基本用法:assert 條件

當條件正確時,什麼也不返回;當條件錯誤時,拋出AssertionError

In [5]: assert 9>5    # 條件正確時,什麼也不返回

In [6]: assert 9<5   # 條件錯誤時,拋出AssertionError
---------------------------------------------------------------------------
AssertionError                            Traceback (most recent call last)
<ipython-input-6-739be7e04005> in <module>
----> 1 assert 9<5

AssertionError:

斷言的錯誤可以自己填寫,用法:assert 條件,’錯誤信息’

In [7]: assert 9<5, 'Error!!!!!'   # 自己填寫錯誤信息
---------------------------------------------------------------------------
AssertionError                            Traceback (most recent call last)
<ipython-input-7-ea55b9c82b31> in <module>
----> 1 assert 9<5, 'Error!!!!!'

AssertionError: Error!!!!!

Python異常到此結束

 

点赞

發佈留言

發佈留言必須填寫的電子郵件地址不會公開。 必填欄位標示為 *